#include "eventPropagation.h"



EventPropagation::EventPropagation()
{
label.set_label( "A label" );

canPropagate.set_label( "Can Propagate" );

canPropagate.set_active( true );


    // :: Main Container :: //

container.pack_start( label );
container.pack_start( entry );
container.pack_start( canPropagate );


    // :: Window :: //

this->add( container );

this->set_title( "Event Propagation" );

this->set_border_width( 10 );

this->show_all_children();


    // :: Events :: //

this->add_events( Gdk::KEY_RELEASE_MASK );


this->signal_key_release_event().connect( sigc::mem_fun( *this, &EventPropagation::onKeyPress ) );

entry.signal_key_release_event().connect( sigc::mem_fun( *this, &EventPropagation::entryKeyPress ) );
}



/*
    This will set the entry's text in the label, everytime a key is pressed
 */

bool EventPropagation::onKeyPress( GdkEventKey *event )
{
    //checking if the entry is on focus, otherwise the label would get changed
    //by pressing keys on the window (when the entry is not on focus), even if canPropagate
    //wasn't active, which would defeat the purpose of the example :)
if ( entry.has_focus() == true )
    {
    label.set_text( entry.get_text() );
    }


return true;
}


/*
    By changing the return value, we allow or not the event to propagate to other elements
 */

bool EventPropagation::entryKeyPress( GdkEventKey *event )
{
if ( canPropagate.get_active() == true )
    {
    return false;
    }

else
    {
    return true;
    }
}
